import 'package:flutter/material.dart';
import 'package:cuidai_plugin/cuidai_plugin.dart';
import 'package:flutter/widgets.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {

  final _formKey = GlobalKey<FormState>();
  final _routeController = TextEditingController();

  @override
  void initState() {
    super.initState();

    Map<String, String> params = {
      "appName": "vitat",
      "schema": "vitat",
      "externalId": "abcd12345",
      "userName": "Joao"
    };

    // Init the Cuidai SDK
    CuidaiPlugin.initSDK(params: params);
  }

  @override
  Widget build(BuildContext context) {

    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Cuidai Plugin example app'),
        ),
        body: Padding(
          padding: const EdgeInsets.symmetric(horizontal: 32.0),
          child: Center(
            child: Column(
              children: [
                Form(
                  key: _formKey,
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: <Widget>[
                      TextFormField(
                        controller: _routeController,
                        decoration: const InputDecoration(
                          hintText: 'Enter the route',
                        ),
                        validator: (value) {
                          if (value.isEmpty) {
                            return 'Please enter the route';
                          }
                          return null;
                        },
                      ),
                      Padding(
                        padding: const EdgeInsets.symmetric(vertical: 16.0),
                        child: ElevatedButton(
                          onPressed: () {
                            if (_formKey.currentState.validate()) {
                              //Open Cuidai screen
                              CuidaiPlugin.route(
                                  deeplink: _routeController.text);
                            }
                          },
                          child: Text('Route'),
                        ),
                      ),
                    ],
                  ),
                )
              ],
            ),
          ),
        ),
      ),
    );
  }
}
